#define export __declspec (dllexport)
#include <windows.h>
#include <stdio.h>

char ds[27];
char *directory = "", *drive = "", *file = "";
long int folders = 0L, files = 0L;
char crt[16], acc[16], mod[16];

export double clearCache()
{
	directory = "";
	drive = "";
	file = "";
	return 0;
}

export char* getCrt(char *f)
{
  if (strncmp(f,file,strlen(f)+1) == 0) return crt;
	HANDLE h;
	FILETIME ftc,fta,ftm;
	SYSTEMTIME st;
	h = CreateFile(f,GENERIC_READ,FILE_SHARE_READ,
		NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
	if (h == INVALID_HANDLE_VALUE) return "";
	if (!GetFileTime(h,&ftc,&fta,&ftm))
	{
		CloseHandle(h);
		return "";
	}
	CloseHandle(h);
	FileTimeToSystemTime(&ftc, &st);
	sprintf(crt,"%u%02u%02u%02u%02u%02u",st.wYear,st.wMonth,st.wDay,st.wHour,st.wMinute,st.wSecond);
	FileTimeToSystemTime(&fta, &st);
	sprintf(acc,"%u%02u%02u%02u%02u%02u",st.wYear,st.wMonth,st.wDay,st.wHour,st.wMinute,st.wSecond);
	FileTimeToSystemTime(&ftm, &st);
	sprintf(mod,"%u%02u%02u%02u%02u%02u",st.wYear,st.wMonth,st.wDay,st.wHour,st.wMinute,st.wSecond);
	return crt;
}

export double setCrt(char *f, char *t)
{
	if (strncmp(f,file,strlen(f)+1) == 0) file = "";
	HANDLE h;
	FILETIME ft;
	SYSTEMTIME st;
	int r1,r2,r3,r4,r5,r6;
	h = CreateFile(f,GENERIC_WRITE,FILE_SHARE_WRITE,
		NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
	if (h == INVALID_HANDLE_VALUE) return -1;
	sscanf(t,"%4i%2i%2i%2i%2i%2i",&r1,&r2,&r3,&r4,&r5,&r6);
	st.wYear = r1;
	st.wMonth = r2;
	st.wDay = r3;
	st.wHour = r4;
	st.wMinute = r5;
	st.wSecond = r6;
	SystemTimeToFileTime(&st,&ft);
	if (!SetFileTime(h,&ft,NULL,NULL))
	{
		CloseHandle(h);
		return -2;
	}
	CloseHandle(h);
	return 0;
}

export char* getAcc(char *f)
{
  if (strncmp(f,file,strlen(f)+1) == 0) return acc;
	HANDLE h;
	FILETIME ftc,fta,ftm;
	SYSTEMTIME st;
	h = CreateFile(f,GENERIC_READ,FILE_SHARE_READ,
		NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
	if (h == INVALID_HANDLE_VALUE) return "";
	if (!GetFileTime(h,&ftc,&fta,&ftm))
	{
		CloseHandle(h);
		return "";
	}
	CloseHandle(h);
	FileTimeToSystemTime(&ftc, &st);
	sprintf(crt,"%u%02u%02u%02u%02u%02u",st.wYear,st.wMonth,st.wDay,st.wHour,st.wMinute,st.wSecond);
	FileTimeToSystemTime(&fta, &st);
	sprintf(acc,"%u%02u%02u%02u%02u%02u",st.wYear,st.wMonth,st.wDay,st.wHour,st.wMinute,st.wSecond);
	FileTimeToSystemTime(&ftm, &st);
	sprintf(mod,"%u%02u%02u%02u%02u%02u",st.wYear,st.wMonth,st.wDay,st.wHour,st.wMinute,st.wSecond);
	return acc;
}

export double setAcc(char *f, char *t)
{
	if (strncmp(f,file,strlen(f)+1) == 0) file = "";
	HANDLE h;
	FILETIME ft;
	SYSTEMTIME st;
	int r1,r2,r3,r4,r5,r6;
	h = CreateFile(f,GENERIC_WRITE,FILE_SHARE_WRITE,
		NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
	if (h == INVALID_HANDLE_VALUE) return -1;
	sscanf(t,"%4i%2i%2i%2i%2i%2i",&r1,&r2,&r3,&r4,&r5,&r6);
	st.wYear = r1;
	st.wMonth = r2;
	st.wDay = r3;
	st.wHour = r4;
	st.wMinute = r5;
	st.wSecond = r6;
	SystemTimeToFileTime(&st,&ft);
	if (!SetFileTime(h,NULL,&ft,NULL))
	{
		CloseHandle(h);
		return -2;
	}
	CloseHandle(h);
	return 0;
}

export char* getMod(char *f)
{
  if (strncmp(f,file,strlen(f)+1) == 0) return mod;
	HANDLE h;
	FILETIME ftc,fta,ftm;
	SYSTEMTIME st;
	h = CreateFile(f,GENERIC_READ,FILE_SHARE_READ,
		NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
	if (h == INVALID_HANDLE_VALUE) return "";
	if (!GetFileTime(h,&ftc,&fta,&ftm))
	{
		CloseHandle(h);
		return "";
	}
	CloseHandle(h);
	FileTimeToSystemTime(&ftc, &st);
	sprintf(crt,"%u%02u%02u%02u%02u%02u",st.wYear,st.wMonth,st.wDay,st.wHour,st.wMinute,st.wSecond);
	FileTimeToSystemTime(&fta, &st);
	sprintf(acc,"%u%02u%02u%02u%02u%02u",st.wYear,st.wMonth,st.wDay,st.wHour,st.wMinute,st.wSecond);
	FileTimeToSystemTime(&ftm, &st);
	sprintf(mod,"%u%02u%02u%02u%02u%02u",st.wYear,st.wMonth,st.wDay,st.wHour,st.wMinute,st.wSecond);
	return mod;
}

export double setMod(char *f, char *t)
{
	if (strncmp(f,file,strlen(f)+1) == 0) file = "";
	HANDLE h;
	FILETIME ft;
	SYSTEMTIME st;
	int r1,r2,r3,r4,r5,r6;
	h = CreateFile(f,GENERIC_WRITE,FILE_SHARE_WRITE,
		NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
	if (h == INVALID_HANDLE_VALUE) return -1;
	sscanf(t,"%4i%2i%2i%2i%2i%2i",&r1,&r2,&r3,&r4,&r5,&r6);
	st.wYear = r1;
	st.wMonth = r2;
	st.wDay = r3;
	st.wHour = r4;
	st.wMinute = r5;
	st.wSecond = r6;
	SystemTimeToFileTime(&st,&ft);
	if (!SetFileTime(h,NULL,NULL,&ft))
	{
		CloseHandle(h);
		return -2;
	}
	CloseHandle(h);
	return 0;
}

export double getFileCount(char *f)
{
	if (f == directory) return (double)files;
	HANDLE h;
	WIN32_FIND_DATA fdat;
	folders = 0L;
	files = 0L;
	h = FindFirstFile(f,&fdat);
	if (h == INVALID_HANDLE_VALUE) return -1;
	if (FindNextFile(h,&fdat) == 0)
	{
		FindClose(h);
		return 0.0;
	}
	while (FindNextFile(h,&fdat) != 0) 
	{
		if ((fdat.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) == 0) files++;
		else folders++;
	}
	FindClose(h);
	return (double)files;
}

export double getDirCount(char *f)
{
	if (f == directory) return (double)folders;
	HANDLE h;
	WIN32_FIND_DATA fdat;
	folders = 0L;
	files = 0L;
	h = FindFirstFile(f,&fdat);
	if (h == INVALID_HANDLE_VALUE) return -1;
	if (FindNextFile(h,&fdat) == 0)
	{
		FindClose(h);
		return 0.0;
	}
	while (FindNextFile(h,&fdat) != 0) 
	{
		if ((fdat.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) == 0) files++;
		else folders++;
	}
	FindClose(h);
	return (double)folders;
}

export char *getDrives()
{
	int d = GetLogicalDrives();
	int n,m = 0;
	for (n = 0; n < 26; n++)
	{
		if ((d & (1 << n)) != 0)
		{
			ds[m++] = (char)(65 + n);
		}
	}
	return ds;
}

export double getTotalSpace(char *f, double unit)
{
	DWORD bps = 0; // bytes per sector
	DWORD spc = 0; // sectors per cluster
	DWORD fc = 0; // free clusters
	DWORD tc = 0; // total clusters
	GetDiskFreeSpace(f, &bps, &spc, &fc, &tc);
	unsigned long long s = (unsigned long long)bps *
												 (unsigned long long)spc *
												 (unsigned long long)tc;
	if (unit > 0) s /= 1000;
	if (unit > 1) s /= 1000;
	if (unit > 2) s /= 1000;
	if (unit > 3) s /= 1000;
	if (unit > -1) return (double)s;
	double r = 0.0;
	while (s > 1000000)
	{
		s /= 1000;
		r += 0.1;
	}
	if ((unit == -1) && (s > 1000))
	{
		s /= 1000;
		r += 0.1;
	}
	return r + (double)s;

}

export double getFreeSpace(char *f, double unit)
{
	DWORD bps = 0; // bytes per sector
	DWORD spc = 0; // sectors per cluster
	DWORD fc = 0; // free clusters
	DWORD tc = 0; // total clusters
	GetDiskFreeSpace(f, &bps, &spc, &fc, &tc);
	unsigned long long s = (unsigned long long)bps *
												 (unsigned long long)spc *
												 (unsigned long long)fc;
	if (unit > 0) s /= 1000;
	if (unit > 1) s /= 1000;
	if (unit > 2) s /= 1000;
	if (unit > 3) s /= 1000;
	if (unit > -1) return (double)s;
	double r = 0.0;
	while (s > 1000000)
	{
		s /= 1000;
		r += 0.1;
	}
	if ((unit == -1) && (s > 1000))
	{
		s /= 1000;
		r += 0.1;
	}
	return r + (double)s;

}

export double getUsedSpace(char *f, double unit)
{
	DWORD bps = 0; // bytes per sector
	DWORD spc = 0; // sectors per cluster
	DWORD fc = 0; // free clusters
	DWORD tc = 0; // total clusters
	GetDiskFreeSpace(f, &bps, &spc, &fc, &tc);
	unsigned long long s = (unsigned long long)bps *
												 (unsigned long long)spc *
												 ((unsigned long long)tc -
												 (unsigned long long)fc);
	if (unit > 0) s /= 1000;
	if (unit > 1) s /= 1000;
	if (unit > 2) s /= 1000;
	if (unit > 3) s /= 1000;
	if (unit > -1) return (double)s;
	double r = 0.0;
	while (s > 1000000)
	{
		s /= 1000;
		r += 0.1;
	}
	if ((unit == -1) && (s > 1000))
	{
		s /= 1000;
		r += 0.1;
	}
	return r + (double)s;
}
